package managers 
{
	import core.Assets;
	import core.Game;
	import flash.geom.Point;
	import objects.Fruits;
	import objects.Dog;
	import states.Play;
	/**
	 * ...
	 * @author miyijura
	 */
	public class CollisionManager 
	{
		private var play:Play;
		//variables para detectar distancias entre puntos
		private var p1:Point = new Point();
		private var p2:Point = new Point();
		
		//variabes para el radio de los objetos
		//juega con estos parametros para ajustar el tamaño del bounding box de los objetos

		//area sensible de las frutas
		private var fruit_radius:int = 32;
		//area sensible del husky
		private var dog_radius:int = 24;
		
		public var scorePoints:Number = 0;
		
		//agregamos la referencia a nuestro estado de juego Play
		public function CollisionManager(play:Play) 
		{
			//guardamos la referencia en una varible
			this.play = play;
		}
		
		//constantemente revisamos si hay colisiones
		public function update():void {
			//metodo que calcula si hay colision entre la fruta y el husky
			fruitCollected();
		}
		
		//usando deteccion de rectangulos
		private function fruitCollected():void {
			//accedemos al manager de frutas
			var fm:Array = play.fruitManager.fruits_array;
			var f:Fruits;
			
			//revisamos las frutas generadas desde arriba de la lista del array
			for (var i:int = fm.length - 1; i >= 0; i--) {
				
				f = fm[i];
				
					if (fm[i].bounds.intersects(play.husky.bounds)) {
						Assets.item_sound.play();
						//llamamos al estado de juego GAME_OVER de la clase Game
						//play.game.changeState(Game.GAME_OVER_STATE);
						checkFruitPoint(f);
						play.particleManager.spawn(f.x, f.y);
						play.fruitManager.destroyFruit(f);
					}
				
			}
		}
		
		private function checkFruitPoint(f:Fruits):void 
		{
			//trace(f.fruitType);
			if (f.fruitType < 6){
				scorePoints += 10;
			} else if (f.fruitType > 5 && f.fruitType < 11) {
				scorePoints += 20;
			} else if (f.fruitType > 10 && f.fruitType < 16) {
				scorePoints += 30;
			} else if (f.fruitType >  15) {
				scorePoints += 50;	
			}
			
			//scorePoints += play.myPoints;
			trace(scorePoints);
			
		}
		
		
		//usando deteccion de radios
		/*private function fruitCollected():void 
		{
			//accedemos al manager de frutas
			var fm:Array = play.fruitManager.fruits_array;
			var f:Fruits;
			//revisamos las frutas generadas desde arriba de la lista del array
			for (var i:int = fm.length - 1; i >= 0; i--) {
				f = fm[i];
				//usamos los puntos para ver la distancia entre puntos
					//primero vemos la posicion del perro en el espacio
					p1.x = play.husky.x;
					p1.y = play.husky.y;
					//ahora de cada fruta
					p2.x = f.x; 
					p2.y = f.y;
				//validamos la distancia entre puntos
					if (Point.distance(p1, p2) < fruit_radius + dog_radius) {
						//llamamos al estado de juego GAME_OVER de la clase Game
						//play.game.changeState(Game.GAME_OVER_STATE);
						play.particleManager.spawn(f.x, f.y);
						play.fruitManager.destroyFruits(f);
					}
				
			}
		}*/
		
	}

}