package managers
{
	
	import core.GamePool;
	import objects.Fruits;
	
	import starling.core.Starling;
	
	import states.Play;
	
	public class FruitsManager
	{
		private var play:Play;
		public var fruits_array:Array;
		private var fruit_pool:GamePool;
		//public var count:int = 0;
		
		public function FruitsManager(play:Play)
		{
			this.play = play;
			fruits_array = new Array();
			fruit_pool = new GamePool(Fruits, 60);
		}
		
		public function update():void
		{
			if(Math.random() < 0.05)
				spawn();
			
			var f:Fruits;
			var len:int = fruits_array.length;
			
			for(var i:int=len-1; i>=0; i--)
			{
				f = fruits_array[i];
				f.x -= 8;
				if(f.x < 0)
					destroyFruit(f);
			}
		}
		
		private function spawn():void
		{
			var f:Fruits = fruit_pool.getSprite() as Fruits;
			fruits_array.push(f);
			f.x = 820;
			f.y = Math.random() * 550 + 50;
			f.scale = 0.5;
			play.addChild(f);
		}
		
		public function destroyFruit(f:Fruits):void
		{
			var len:int = fruits_array.length;
			
			for(var i:int=0; i<len; i++)
			{
				if(f == fruits_array[i])
				{
					fruits_array.splice(i, 1);
					//f.removeFromParent(true);
					fruit_pool.returnSprite(f);
					f.x = 820;
				}
			}
			
		}
		
		public function destroy():void
		{
			fruit_pool.destroy();
			fruit_pool = null;
			fruits_array = null;
		}
	}
}