package managers
{
	import core.GamePool;	
	import objects.Sparks;
	import starling.core.Starling;
	import starling.events.Event;
	
	import states.Play;

	public class ParticleManager
	{
		private var play:Play;
		private var gamePool:GamePool;
		
		//referencia a la clase Play
		public function ParticleManager(play:Play)
		{
			this.play = play;
			//creamos 100 objetos de particulas
			gamePool = new GamePool(Sparks, 100);
		}
		
		public function spawn(x:int, y:int):void
		{
			//hacemos un cast a Sparks
			var spark:Sparks = gamePool.getSprite() as Sparks;
			//colocamos el emisor de particulas al centro del objeto
			spark.emitterX = x;
			spark.emitterY = y;
			//iniciamos la particula y colocamos la duracion en segundos
			spark.start(0.2);
			//agregamos la particula al display list de Play
			play.addChild(spark);
			//agregamos la particula al juggler, si no lo haces no hay animacion
			Starling.juggler.add(spark);
			//evento que se dispara cuando la animacion se completa
			spark.addEventListener(Event.COMPLETE, onComplete);
		}
		
		private function onComplete(e:Event):void
		{
			//nuevo cast para saber cual particula termino
			var spark:Sparks = e.currentTarget as Sparks;
			//quitamos del juggler
			Starling.juggler.remove(spark);
			//regresamos  al pool
			if(gamePool != null)
				gamePool.returnSprite(spark);
		}
		//limpiamos todo
		public function destroy():void
		{
			gamePool.destroy();
			gamePool = null;
		}
	}
}