package objects 
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.easing.Sine;
	import core.Assets;
	import starling.display.MovieClip;
	import starling.events.EnterFrameEvent;
	import starling.events.Event;
	import starling.textures.Texture;
	import com.greensock.plugins.BezierPlugin;
	
	/**
	 * ...
	 * @author miyijura
	 */
	public class BadBirds extends MovieClip 
	{
		public var enemyType:Vector.<Texture>;
		public var speed:uint;
		public var attackSpeed:Number;
		
		public function BadBirds(enemyType:Vector.<Texture>, speed:int=10) 
		{
			super(enemyType, speed);
			
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			//posicionemoslos en el stage
			this.x = stage.stageWidth + 120;
			//hay que girarlos!
			this.scaleX = -1;
			//modificamos pivotes
			this.pivotX = this.width * 0.5;
			this.pivotY = this.height * 0.5;
		}
		
		public function attack():void 
		{
			trace("ATTACK!");
			this.visible = true;
			TweenLite.to(this, attackSpeed, {x:-150, onComplete:reuseBirds, delay:0.5 } );
			
		}
		
		public function reuseBirds():void {
			trace("REUSE");
			this.visible = false;
			this.x = stage.stageWidth + 120;
			this.y = Math.ceil(Math.random() * 550);
			//attack();
		}
		public function attackWave():void 
		{
			trace("ATTACK WAVE!");
			this.visible = true;
			//TweenMax.to(this, attackSpeed, {x:-150, onComplete:reuseBirds, delay:0.5 } );
			TweenMax.to(this, attackSpeed, {bezier:{autoRotate:false, values:[{x:stage.stageWidth / 2, y:Math.ceil(Math.random() * 400)}, {x:-150, y:this.y -= 100}]},onComplete:reuseBirds, delay:0.5, ease:Sine.easeOut});
		}
		
		
		public function destroy():void {
			
		}
		
	}

}