package objects 
{
	import core.Assets;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	
	/**
	 * ...
	 * @author miyijura
	 */
	public class BgParallax extends Sprite 
	{
		private var blueSky:Image;
		
		private var mountains1:Image;
		private var mountains2:Image;
		
		private var far_woods1:Image;
		private var far_woods2:Image;
		
		private var clouds1:Image;
		private var clouds2:Image;
		
		private var trees1:Image;
		private var trees2:Image;
		
		public var speed:Number = 2;
		
		public function BgParallax() 
		{
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			//creamos un nuevo cielo azul y usamos una textura de color puro
			blueSky = new Image(Texture.fromColor(stage.stageWidth, stage.stageHeight, 0xff82b6ff));
			addChild(blueSky);
			
			//creamos una imagen para las nubes
			clouds1 = new Image(Assets.ta.getTexture("clouds.png"));
			clouds2 = new Image(Assets.ta.getTexture("clouds.png"));
			clouds2.x = stage.stageWidth;
			addChild(clouds1);
			addChild(clouds2);
			
			//creamos una imagen y aplicamos la textura para las montañas
			mountains1 = new Image(Assets.ta.getTexture("mountains.png"));
			mountains2 = new Image(Assets.ta.getTexture("mountains.png"));
			mountains2.x = stage.stageWidth;
			addChild(mountains1);
			addChild(mountains2);
			
			//creamos una imagen para el bosque lejano
			far_woods1 = new Image(Assets.ta.getTexture("far_woods.png"));
			far_woods2 = new Image(Assets.ta.getTexture("far_woods.png"));
			far_woods2.x = stage.stageWidth;
			addChild(far_woods1);
			addChild(far_woods2);
			
			//creamos una imagen para los arboles cercanos
			trees1 = new Image(Assets.ta.getTexture("trees.png"));
			trees2 = new Image(Assets.ta.getTexture("trees.png"));
			trees2.x = stage.stageWidth;
			addChild(trees1);
			addChild(trees2);
		}
		
		public function update():void {
			//clouds
			clouds1.x -= speed * 0.02;
			if (clouds1.x <= -clouds1.width)
				clouds1.x = stage.stageWidth
				
			clouds2.x -= speed * 0.02;
			if (clouds2.x <= -clouds2.width)
				clouds2.x = stage.stageWidth;
				
			//mountains
			mountains1.x -= speed * 0.05;
			if (mountains1.x <= -mountains1.width)
				mountains1.x = stage.stageWidth
				
			mountains2.x -= speed * 0.05;
			if (mountains2.x <= -mountains2.width)
				mountains2.x = stage.stageWidth;
				
			//far woods
			far_woods1.x -= speed * 0.4;
			if (far_woods1.x <= -far_woods1.width)
				far_woods1.x = stage.stageWidth
				
			far_woods2.x -= speed * 0.4;
			if (far_woods2.x <= -far_woods2.width)
				far_woods2.x = stage.stageWidth;
				
			//trees
			trees1.x -= speed * 1;
			if (trees1.x <= -trees1.width)
				trees1.x = stage.stageWidth
				
			trees2.x -= speed * 1;
			if (trees2.x <= -trees2.width)
				trees2.x = stage.stageWidth;
		}
		
		/*public function destroy():void {
			trees1.removeFromParent(true);
			trees2.removeFromParent(true);
			far_woods1.removeFromParent(true);
			far_woods2.removeFromParent(true);
			mountains1.removeFromParent(true);
			mountains2.removeFromParent(true);
			clouds1.removeFromParent(true);
			clouds2.removeFromParent(true);
			removeFromParent(true);
		}*/
		
	}

}