package states 
{
	import com.greensock.TimelineLite;
	import com.greensock.TweenLite;
	import core.Assets;
	import core.Game;
	import interfaces.IState;
	import objects.DogLost;
	import starling.display.Button;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;
	import starling.text.TextFormat;
	
	/**
	 * ...
	 * @author miyijura
	 */
	public class GameOver extends Sprite implements IState 
	{
		private var game:Game;
		private var the_message:TextField;
		private var restart_button:Button;
		private var menu_button:Button;
		
		public function GameOver(game:Game) 
		{
			this.game = game;
			addEventListener(Event.ADDED_TO_STAGE, init);
			
			//agregamos la misma pantalla negra
			var blackScreen:DogLost = new DogLost();
			addChild(blackScreen);
			
			
		}
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			trace("GAME OVER");
			
			the_message = new TextField(300, 200, "GAME OVER");
			the_message.format.font = "myFont";
			the_message.format.size = 200;
			the_message.format.color = 0xffffff;
			//posicionamos el campo de texto al centro en X
			the_message.x = stage.stageWidth / 2 - the_message.width / 2;
			//y al centro de la pantalla en Y
			the_message.y = stage.stageHeight / 2 -  the_message.height / 2;
			//alpha
			the_message.alpha = 0;
			//y al display list
			addChild(the_message);
			
			//agregamos los botones
			restart_button = new Button(Assets.ta.getTexture("but_play.png"));
			menu_button = new Button(Assets.ta.getTexture("but_menu.png"));
			//propiedades iniciales del boton
			restart_button.scale = 0.3;
			restart_button.alpha = 0;
			
			menu_button.scale = 0.3;
			menu_button.alpha = 0;
			//pivote al centro
			restart_button.pivotX = restart_button.width * 0.5;
			restart_button.pivotY = restart_button.height * 0.5;
			
			menu_button.pivotX = menu_button.width * 0.5;
			menu_button.pivotY = menu_button.height * 0.5;
			//posicion en X
			restart_button.x = stage.stageWidth / 2 - restart_button.width / 2;
			menu_button.x = stage.stageWidth / 2 - restart_button.width / 2;
			//posicion en Y
			restart_button.y = the_message.y + the_message.height;
			menu_button.y = restart_button.y + menu_button.height + 50;
			//agregamos al display list
			addChild(restart_button);
			addChild(menu_button);
			//TWEENS
			//TweenLite.to(the_message, 1, {alpha:1 } );
			var tl:TimelineLite = new TimelineLite();
			tl.to(the_message, 2, {alpha:1, delay:2})
				.to(restart_button, 1, { scale:0.5, alpha:1 } )
				.to(menu_button, 1, {scale:0.5, alpha:1})	;
			
			//agregamos un evento que reinicie el juego, o si lo prefieres que te lleve al menu.
			restart_button.addEventListener(Event.TRIGGERED, restartGame);
			menu_button.addEventListener(Event.TRIGGERED, menuGame);
		}
		
		private function menuGame(e:Event):void 
		{
			menu_button.removeEventListener(Event.TRIGGERED, restartGame);
			//cambiamos el estado de juego a menu
			game.changeState(Game.MENU_STATE);
		}
		
		private function restartGame(e:Event):void 
		{
			restart_button.removeEventListener(Event.TRIGGERED, restartGame);
			//cambiamos el estado de juego a play para reiniciar el juego
			game.changeState(Game.PLAY_STATE);
		}
		
		/* INTERFACE interfaces.IState */
		
		public function update():void 
		{
			
			
		}
		
		public function destroy():void 
		{
			//eliminamos todo de esta pantalla
			removeFromParent(true);
		}
		
	}

}