package states 
{
	import com.greensock.TimelineMax;
	import com.greensock.TweenLite;
	import core.Assets;
	import core.Game;
	import flash.media.SoundChannel;
	import interfaces.IState;
	import objects.Background;
	import starling.display.Button;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.EnterFrameEvent;
	import starling.events.Event;
	
	/**
	 * ...
	 * @author miyijura
	 */
	public class Menu extends Sprite implements IState 
	{
		private var game:Game;
		private var but_play:Button;
		private var menu_bg:Background;
		private var game_logo:Image;
		private var art:Image;
		private var myChannel:SoundChannel = new SoundChannel();
		
		public function Menu(game:Game) 
		{
			this.game = game;
			addEventListener(Event.ADDED_TO_STAGE, init);
			
		}
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			//add the background
			menu_bg = new Background();
			//selecciona la textura, si asi lo deseas
			//menu_bg.bg_texture = Assets.bg_2;
			addChild(menu_bg);
			
			//add the buttons
			but_play = new Button(Assets.ta.getTexture("but_play.png"), "");
			addChild(but_play);
			but_play.x = stage.stageWidth / 2;
			but_play.y = 450;
			//pivote al centro
			but_play.pivotX = but_play.width * 0.5;
			but_play.pivotY = but_play.height * 0.5;
			//hagamoslo mas pequeño
			but_play.scaleX = 0.5;
			but_play.scaleY = 0.5;
			but_play.addEventListener(Event.TRIGGERED, playMe);
			
			//add the logo
			game_logo = new Image(Assets.ta.getTexture("game_name.png"));
			//mas pequeño
			game_logo.scaleX = 0.5;
			game_logo.scaleY = 0.5;
			//init pos
			game_logo.x = stage.stageWidth / 2 - game_logo.width / 2;
			game_logo.y = stage.stageHeight;

			addChild(game_logo);	
			
			//agregando el arte
			art = new Image(Assets.ta.getTexture("fenrir_wolf_ol.png"));
			art.x = stage.stageWidth / 2 - art.width / 2;
			art.y = stage.stageHeight;
			addChild(art);
			
			//agregando el tween
			TweenLite.to(game_logo, 2, { y:stage.stageHeight / 2 - game_logo.height / 2 , delay:2 } );
			TweenLite.to(art, 2, { y:20 , delay:4 } );
			
			var timeline:TimelineMax = new TimelineMax( { repeat:-1, yoyo:true, repeatDelay:0 } );
			timeline.to(but_play, 1, { scaleX:0.7, scaleY:0.7 } );
			
			//musica!
			myChannel = Assets.intro_music.play(0, 9999);
		}
				
		private function playMe(e:Event):void 
		{
			game.changeState(Game.PLAY_STATE);
		}
		
		/* INTERFACE interfaces.IState */
		
		public function update():void 
		{
			//el bg puede moverse...si asi lo deseas
			//menu_bg.update();
			
			/*var myDate:Date = new Date();
			art.y = 100 +  Math.cos(myDate.getTime() * 0.002) * 25;*/
		}
		
		public function destroy():void 
		{
			//quitamos del display list y lo enviamos al garbage collector
			removeFromParent(true);
			//quitamos la musica
			//musica!
			myChannel.stop();
		}
		
	}

}